var sdk_pageMod = require("sdk/page-mod");
var sdk_tabs = require("sdk/tabs");
var sdk_timers = require("sdk/timers");
var sdk_notifications = require("sdk/notifications");
var sdk_data = require("sdk/self").data;

var tab;
var timer_id;

sdk_pageMod.PageMod({
	include: "*.vb-paradise.de",
	onAttach: startHandler
});

var tracked = false;

function startHandler(worker) {
	if (!tracked)
	{
		tracked = true;
		tab = worker.tab;
		checkNewMessages();
		tab.on("ready", onPageLoaded);
		tab.on("close", stopHandler);
		timer_id = sdk_timers.setInterval(reloadIfInactive, 10000);
	}
}

function stopHandler() {
	tab.removeListener("ready", onPageLoaded);
	sdk_timers.clearInterval(timer_id);
	tracked = false;
	msgshown = false;
}

function reloadIfInactive() {
	if (tab.id != sdk_tabs.activeTab.id) {
		tab.reload();
	}
}

function onPageLoaded() {
	if (tab.url.search("vb\-paradise\.de") != -1) {
		checkNewMessages();
	} else {
		stopHandler();
	}
}

function checkNewMessages() {
	var script = tab.attach({
		contentScriptFile: sdk_data.url("check-script.js"),
		contentScriptWhen: "end"
	});
	script.port.on("notificationCountMessage", onNotificationCountMessage);
}

var msgshown = false;

function onNotificationCountMessage(message) {
	if (parseInt(message) > 0) {
		if (!msgshown) {
			msgshown = true;
			sdk_notifications.notify({
				title: "VB-Paradise Notification",
				text: "You received a new notification on vb-paradise.de!",
				onClick: tab.activate
			});
			var script = tab.attach({
				contentScriptFile: sdk_data.url("audio-script.js"),
				contentScriptWhen: "end"
			});
		}
	} else {
		msgshown = false;
	}
}